﻿package
{
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.events.Event;
	
	public class Main extends MovieClip
	{
		public var dragObj:dragMe; //the dragging object
		public var rockObj:rock; //the rock object
		public var stateText:TextField; //the state textfield

		public function Main()
		{
			rockObj = this.getChildByName("rocks") as rock;// as rock; //here we get the item from the stage. We could also create a new one instead.
														//the "as" is used as a typecast which means that flash will now recognize the object as a "rock" and not just a movieclip

			dragObj = this.getChildByName("drag") as dragMe; //same here for the dragging item
			
			stateText = this.getChildByName("stateText") as TextField; //and for the status textfield
			
			this.addEventListener(Event.ENTER_FRAME, update); //update loop
		}
		
		private function update(evt:Event):void //simple enter_frame loop. In a real game you should also test the time for each frame!
		{										//You can check my post on frame independent gameplay loops on http://www.fabricebacquart.info
			var collide:Boolean = false; //used to know if we had a collision
			
			if (dragObj.hitTestObject(rockObj))
			{
				for (var i:int = 0; i < rockObj.hitBoxes.length; ++i)
				{
					if (dragObj.hitTestObject(rockObj.hitBoxes[i]))
					{
						rockObj.hitBoxes[i].visible = true; //highlighting the hitbox that we just hit by making it visible
						collide = true; //there is a collision
						break; //since there was a collision we stop the loop;
					}
					else
						rockObj.hitBoxes[i].visible = false; //resetting the hitbox to invisible
				}
			}
			
			if (collide) //there was a collision
				stateText.replaceText(0, stateText.length, new String("COLLIDING !!!"));			
			else //there was no collision
				stateText.replaceText(0, stateText.length, new String("NOT COLLIDING"));
		}
	}//class
}//package
