﻿package
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Point;
	
	public class dragMe extends MovieClip
	{
		public var beingDragged:Boolean; //is the object currently being dragged ?
		
		public function dragMe()
		{
			beingDragged = false; //Not dragged until we click on it
			this.addEventListener(MouseEvent.CLICK, startDragging); //listener callback for when we click on the object
		}
		
		private function startDragging(evt:MouseEvent):void
		{
			if (!beingDragged) //if the object is not being dragged, start dragging !
			{
				beingDragged = true; //we are starting to drag the object
				this.addEventListener(Event.ENTER_FRAME, updatePosition); //listener callback for every frame so that we can update the position of the object
			}
			else //else it means we are dragging it already
			{
				beingDragged = false; //we stop draggint the object
				this.removeEventListener(Event.ENTER_FRAME, updatePosition); //remove the callback so that we won't update the position anymore
			}
		}

		private function updatePosition(evt:Event):void
		{
			//translating mouse coordinates to global coordinates
			var coords:Point = localToGlobal(new Point(mouseX, mouseY));
			//setting the position of this item to the position of the mouse
			this.x = coords.x;
			this.y = coords.y;
		}
	}//class
}//package
